<script>
	import { fade, fly } from 'svelte/transition';
	import { linear, sineInOut } from 'svelte/easing';
	import routes from '$lib/routes';
	import SidebarLink from './SidebarLink.svelte';
	import SidebarLogo from './SidebarLogo.svelte';

	const TRANSITION_DURATION = 300;

	export let expanded = false;

	const close = () => (expanded = false);

	export const open = () => (expanded = true);
</script>

<!-- Off-canvas menu for mobile, show/hide based on off-canvas menu state. -->
{#if expanded}
	<div class="fixed inset-0 flex z-40 md:hidden" role="dialog" aria-modal="true">
		<div
			class="fixed inset-0 bg-gray-600 bg-opacity-75"
			aria-hidden="true"
			transition:fade={{ duration: TRANSITION_DURATION, easing: linear }}
		/>

		<div
			class="relative flex-1 flex flex-col max-w-xs w-full bg-white"
			transition:fly={{ duration: TRANSITION_DURATION, easing: sineInOut, x: -320, opacity: 1 }}
		>
			<div
				class="absolute top-0 right-0 -mr-12 pt-2"
				transition:fade={{ duration: TRANSITION_DURATION, easing: sineInOut }}
			>
				<button
					class="ml-1 flex items-center justify-center h-10 w-10 rounded-full focus:outline-none focus:ring-2 focus:ring-inset focus:ring-white"
					on:click={close}
				>
					<span class="sr-only">Close sidebar</span>
					<!-- Heroicon name: outline/x -->
					<svg
						class="h-6 w-6 text-white"
						xmlns="http://www.w3.org/2000/svg"
						fill="none"
						viewBox="0 0 24 24"
						stroke="currentColor"
						aria-hidden="true"
					>
						<path
							stroke-linecap="ro@und"
							stroke-linejoin="round"
							stroke-width="2"
							d="M6 18L18 6M6 6l12 12"
						/>
					</svg>
				</button>
			</div>

			<div class="flex-1 h-0 pt-5 pb-4 overflow-y-auto flex flex-col justify-between">
				<div>
					<div class="flex-shrink-0 flex items-center px-4">
						<SidebarLogo />
					</div>
					<nav class="mt-5 px-2 space-y-1">
						{#each routes as route}
							<SidebarLink href={route.href}>
								<slot slot="icon">
									{route.icon}
								</slot>
								{route.name}
							</SidebarLink>
						{/each}
					</nav>
				</div>
				<a sveltekit:prefetch href="/" class="mt-5 px-2 space-y-1 text-center text-blue-500 hover:underline focus:underline">
					Retour vers mon.infoclimat.fr
				</a>
			</div>
		</div>

		<div class="flex-shrink-0 w-14">
			<!-- Force sidebar to shrink to fit close icon -->
		</div>
	</div>
{/if}

<!-- Static sidebar for desktop -->
<div class="hidden md:flex md:flex-shrink-0">
	<div class="flex flex-col w-64">
		<!-- Sidebar component, swap this element with another sidebar if you like -->
		<div class="flex flex-col h-0 flex-1 border-r border-gray-200 bg-white">
			<div class="flex-1 flex flex-col pt-5 pb-4 overflow-y-auto">
				<div class="flex items-center flex-shrink-0 px-4">
					<SidebarLogo />
				</div>
				<div class="flex-1 flex flex-col overflow-y-auto">
					<nav class="flex-1 px-2 py-4 bg-white space-y-1">
						{#each routes as route}
							<SidebarLink href={route.href}>
								<slot slot="icon">
									{route.icon}
								</slot>
								{route.name}
							</SidebarLink>
						{/each}
					</nav>
				</div>
				<a sveltekit:prefetch href="/" class="mt-5 px-2 space-y-1 text-center text-blue-500 hover:underline focus:underline">
					Retour vers mon.infoclimat.fr
				</a>
			</div>
		</div>
	</div>
</div>
